#include <stdio.h>
#include <stdlib.h>
#define TRUE 1

/* **************************************** */

struct int_cons {
  int first;
  struct int_cons * rest; /* NULL => empty */
};

typedef struct int_cons * list;

list cons(int i, list ls) {
  list ls2;
  
  ls2 = (list)malloc(sizeof(struct int_cons));
  
  ls2->first = i;
  ls2->rest = ls;
  
  return ls2;
}

void print_list(struct int_cons * ls) {
  for (; ls != NULL; ls = ls->rest) {
    printf("%d\n", ls->first);
  }
}

/* **************************************** */

void fail(char *msg) {
  fprintf(stderr, "%s\n", msg);
  exit(1);
}

/* **************************************** */

int is_digit(int c) {
  return ((c >= '0') && (c <= '9'));
}

int digit_val(int c) {
  return c - '0';
}

int read_number(FILE* in, int n) {
  while (TRUE) {
    int c = fgetc(in);
  
    if (c == ' ') 
      return n;
    else if (is_digit(c)) {
      n = (n * 10) + digit_val(c);
    } else
      fail("bad number");
  }
}

list read_numlist(FILE* in) {
  int c = fgetc(in);
  if (c == '.') {
    return NULL;
  } else if (is_digit(c)) {
    int n = read_number(in, digit_val(c));
    return cons(n, read_numlist(in));
    /* we could turn the recursion into a loop
       by using a list container that let us put
       integers on the end of the list */
  } else
    fail("bad input");
}

/* **************************************** */

int main()
{
  list l;

  l = read_numlist(stdin);

  print_list(l);
}

